<?php

function shellfix($s){return "'".str_replace("'", "'\''", $s)."'";}

$error = '';

if(strlen($text) && isset($type))
{
  exec('barcodehelper '.shellfix($text).' '.(int)($type), $lines);
  if(count($lines) < 5)
  {
    $error = 'The selected setup was not supported or valid.';
  }
  else
  {
    $data = array();
    foreach($lines as $s)
      $data[$s[0]] = substr($s, 2);
    
    $margin   = (int)$data['M'];
    $partial  = $data['P'];
    $textinfo = $data['T'];
    
    $scalef = 1.0 * $scalef;
    if($scalef < 1.0)
      $scalef = 1.0;
    elseif($scalef > 10.0)
      $scalef = 10.0;
    
    $bars = array();
    $chrs = array();

    $maxxpos = 0;
    $maxypos = 80*$scalef;

    $dotext = 1;
    $mode = '-';
    $xpos = $margin + (int)$partial[0] * $scalef;
    for($c=$i=1; $c<strlen($partial); $c++,$i++)
    {
      $ch = $partial[$c];
      if($ch == '+' || $ch == '-')
      {
        $mode = $ch; $i++; continue;
      }
      $j = ereg('[0-9]', $ch) ? ((int)$ch) : (1+ord($ch)-ord('a'));
      if($i % 2) // bar
      {
        $x0 = $xpos;
        $y0 = $margin;
        $yr = $maxypos;
        if($dotext) // text?
        {
          if($mode == '-')
          {
            $y0 += (ereg('[0-9]', $ch) ? 10 : 5) * $scalef;
            $yr -= (ereg('[0-9]', $ch) ? 10 : 5) * $scalef;
          }
          else
          {
            $y0 += (ereg('[0-9]', $ch) ? 10 : 0) * $scalef;
            $yr -= (ereg('[0-9]', $ch) ? 20 :10) * $scalef;
          }
        }
        $width = $scalef * $j - 0.15; // 0.15 = ink spread space
        $height = $yr;
        
        // OUTPUT BAR: x0,y0,  width,height
        $bars[] = array('x0'=>$x0, 'y0'=>$y0, 'width'=>$width, 'height'=>$height);
      }
      $xpos += $scalef * $j;
      $maxxpos = $xpos;
    }
    
    $mode = '-';
    if($dotext)
    {
      $k=0; /* k is the "previous font size" */
      foreach(explode(' ', $textinfo) as $ptr)
      {
        while($ptr[0]=='-' || $ptr[0]=='+') { $mode = $ptr[0]; $ptr = substr($ptr, 1); }
        sscanf($ptr, '%lf:%lf:%c', $f1, $f2, $c);
        
        $x0 = $margin + $f1 * $scalef;
        if($mode == '-')
          $y0 = $margin;
        else
          $y0 = $margin + $maxypos - 8*$scalef;
        $fontsize = $f2 * $scalef;
        
        // OUTPUT CHAR: x0,y0, fontsize, $c;
        $chrs[] = array('x0'=>$x0, 'y0'=>$y0, 'size'=>$fontsize, 'ch'=>$c);
      }
    }
    $im = ImageCreateTrueColor($maxxpos, $maxypos);
    $back = ImageColorAllocate($im, 250,255,255);
    $black = ImageColorAllocate($im, 0,0,0);
    ImageFilledRectangle($im, 0,0,$maxxpos,$maxypos, $back);

    foreach($bars as $tab)
    {
      //print "OUTPUT BAR: pos=($tab[x0],$tab[y0]) size=($tab[width],$tab[height])\n";
      ImageFilledRectangle($im,
        (int)(0.5 + $tab[x0]),
        (int)(0.5 + $maxypos-($tab[y0]+$tab[height]-1)),
        ceil($tab[x0]+$tab[width]-1),
        ceil($maxypos-$tab[y0]),
        $black);
    }
    foreach($chrs as $tab)
    {
      $x0 = $tab[x0];
      $y0 = $tab[y0];
      $size = $tab[size];
      //$x0 -= $size/2;
      //$y0 -= $size/2;
      $y0 = $maxypos - $y0;
      
      //print "OUTPUT CHAR: pos=($tab[x0],$tab[y0]) size=$tab[size], char='$tab[ch]'\n";
      ImageTTFtext($im, $size*0.6, 0, $x0,$y0, $black,
                   '/WWW/verdana.ttf',
                   $tab[ch]
                  );
    }
    header('Content-type: image/png');
    ImagePNG($im);
    ImageDestroy($im);
    return;
  }
/*
Example:
A ikimashou
P 0 b1 a2 a4 142112241211142112413111121124114212122411134111124211221114 b3 c1 a1 b
T 11:12:i 22:12:k 33:12:i 44:12:m 55:12:a 66:12:s 77:12:h 88:12:o 99:12:u
E code 128-B
X 0
M 10
*/
}


header('Content-type: text/html; charset=iso-8859-1');

echo '<html><head><title>',
         htmlspecialchars('Barcode generator online'),
     '</title></head>',
     '<body>',
      '<h1>Barcode generator online</h1>';

print "\n";
if($error)
{
  echo '<p>', htmlspecialchars($error), '</p>';
  print "\n";
}

?>
<form method=GET action="barcode.php">
 Text: <input type=text maxlength=64 value="6413600013105"><br>
 Scale factor: <input type=text maxlength=10 size=5 name=scalef value="1.0"><br>
 Barcode type:
<?php

$lines=array();
exec("grep '^ *BARCODE_' /usr/include/barcode.h|sed 's/[= 0]*,//'", $lines);

print '<select name=type>';

foreach($lines as $c => $l)
{
  echo '<option value=', $c, '>';
  
  $s1 = str_replace('BARCODE_','',ereg_replace('/.*','',str_replace(' ', '', $l)));
  $s2 = ereg_replace('^ *[A-Z0-9_]* *', '', $l);
  
  $s = sprintf('%8s %s', $s1, $s2);
  print str_replace(' ', '', htmlspecialchars($s));
  
  echo '</option>';
  echo "\n";
}
?>
  </select>
<br>
 <input type=submit value="Generate barcode">
</form>

 </body>
</html>
